#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/types.h>
#include <unistd.h>

#include <netlink/netlink.h>


static int nl_socket(int setport)
{
	struct nl_sock *genl_sk;
	int err;

	genl_sk = nl_socket_alloc();
	if (!genl_sk) {
		fprintf(stderr, "nl_socket_alloc(): %s\n",
		        strerror(errno));
		return;
	}
	if (setport) {
		nl_socket_set_local_port(genl_sk, getpid() + 1);
		printf("set manually the local port to %u (pid: %u)\n",
		       getpid() + 1, getpid());
	} else
		printf("local port has been set by the libnl to %u (pid: %u)\n",
		       nl_socket_get_local_port(genl_sk), getpid());

	err = genl_connect(genl_sk);
	if (err < 0) {
		fprintf(stderr,
			"ERROR: genl_connect(): %s (local port: %u, pid: %u)\n",
		        nl_geterror(err), nl_socket_get_local_port(genl_sk),
			getpid());
		return -1;
	}
	while(setport);
	nl_socket_free(genl_sk);
}

int main(int argc, char **argv)
{
        int rc = 0;

	if (argc > 1)
		rc = nl_socket(1);
	else {
		sleep(1);
		rc = nl_socket(0);
	}

	exit(rc);
}
